/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AArch64PostLegalizerCombinerImpl Combiner Match Table                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AArch64PostLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 0;	 // "copy_prop"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_const", 8) != 0)
        break;
      return 24;	 // "mul_const"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "r_to_bsp", 8) != 0)
        break;
      return 85;	 // "or_to_bsp"
    }
    break;
  case 10:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 56;	 // "i2p_to_p2i"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 55;	 // "p2i_to_i2p"
    }
    break;
  case 11:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 61;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 32;	 // "match_addos"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 42;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtmultomull", 11) != 0)
        break;
      return 92;	 // "extmultomull"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 23;	 // "redundant_or"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_sext", 11) != 0)
        break;
      return 6;	 // "sext_of_sext"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 4;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 16;	 // "load_and_mask"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 37;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 41;	 // "merge_unmerge"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 20;	 // "redundant_and"
    case 'u':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
          break;
        return 40;	 // "unmerge_merge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
          break;
        return 43;	 // "unmerge_undef"
      }
      break;
    }
    break;
  case 14:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 10;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 9;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_same_val", 13) != 0)
        break;
      return 52;	 // "binop_same_val"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_fneg_fold", 13) != 0)
        break;
      return 58;	 // "fneg_fneg_fold"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 7;	 // "sext_of_anyext"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 5;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 15;	 // "extending_loads"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 70;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 50;	 // "select_same_val"
    }
    break;
  case 16:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 8;	 // "anyext_of_anyext"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_mul_cmlt", 15) != 0)
        break;
      return 90;	 // "combine_mul_cmlt"
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 84;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 34;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 2;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 1;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 72;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_trunc_fold", 16) != 0)
        break;
      return 57;	 // "anyext_trunc_fold"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 82;	 // "erase_undef_store"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_to_iminmax", 16) != 0)
        break;
      return 36;	 // "select_to_iminmax"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_int_zero", 16) != 0)
        break;
      return 73;	 // "undef_to_int_zero"
    }
    break;
  case 18:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 53;	 // "binop_left_to_zero"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_merge_to_zext", 16) != 0)
          break;
        return 38;	 // "fold_merge_to_zext"
      case 'p':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "trunc_fpext_fold", 16) != 0)
          break;
        return 66;	 // "fptrunc_fpext_fold"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 3;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 10 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 54;	 // "binop_right_to_zero"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "onstant_fold_binop", 18) != 0)
        break;
      return 48;	 // "constant_fold_binop"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 13;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 47;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 69;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 51;	 // "right_identity_zero"
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tate_out_of_range", 17) != 0)
          break;
        return 30;	 // "rotate_out_of_range"
      }
      break;
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_constant_cmp", 16) != 0)
          break;
        return 35;	 // "select_constant_cmp"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_trunc_sextload", 16) != 0)
          break;
        return 18;	 // "sext_trunc_sextload"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 77;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 65;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 46;	 // "merge_of_x_and_undef"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_sext_inreg", 19) != 0)
        break;
      return 25;	 // "redundant_sext_inreg"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "plit_store_zero_128", 19) != 0)
        break;
      return 71;	 // "split_store_zero_128"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 78;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 45;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_concat_vector", 20) != 0)
        break;
      return 86;	 // "combine_concat_vector"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "utate_anyext_to_zext", 20) != 0)
        break;
      return 14;	 // "mutate_anyext_to_zext"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 60;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 74;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 44;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "onstant_fold_fp_binop", 21) != 0)
        break;
      return 49;	 // "constant_fold_fp_binop"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 33;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 79;	 // "propagate_undef_any_op"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_int", 21) != 0)
        break;
      return 59;	 // "right_identity_one_int"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 63;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 12;	 // "buildvector_of_truncate"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 80;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 75;	 // "binop_left_undef_to_zero"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_of_sext_inreg", 23) != 0)
        break;
      return 11;	 // "sext_inreg_of_sext_inreg"
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 21;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 27;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 28;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 62;	 // "buildvector_identity_fold"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 68;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 76;	 // "binop_right_undef_to_undef"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_indexed_load_store", 22) != 0)
          break;
        return 17;	 // "combine_indexed_load_store"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_fp_constant_to_rhs", 22) != 0)
          break;
        return 88;	 // "commute_fp_constant_to_rhs"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtractvecelt_pairwise_add", 25) != 0)
        break;
      return 22;	 // "extractvecelt_pairwise_add"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 67;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 91;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 87;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 64;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 39;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "propagate_undef_shuffle_mask", 28) != 0)
      break;
    return 81;	 // "propagate_undef_shuffle_mask"
  case 29:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 29;	 // "bitfield_extract_from_shr_and"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 31;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 32:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "bitfield_extract_from_sext_inreg", 32) != 0)
      break;
    return 26;	 // "bitfield_extract_from_sext_inreg"
  case 36:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_extract_vec_elt_out_of_bounds", 36) != 0)
      break;
    return 83;	 // "insert_extract_vec_elt_out_of_bounds"
  case 37:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "hoist_logic_op_with_same_opcode_hands", 37) != 0)
      break;
    return 19;	 // "hoist_logic_op_with_same_opcode_hands"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 89;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 93}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AArch64PostLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AArch64PostLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AArch64PostLegalizerCombinerOption;
static cl::list<std::string> AArch64PostLegalizerCombinerDisableOption(
    "aarch64postlegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AArch64PostLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AArch64PostLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AArch64PostLegalizerCombinerOnlyEnableOption(
    "aarch64postlegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AArch64PostLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AArch64PostLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AArch64PostLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AArch64PostLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AArch64PostLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AArch64PostLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64PostLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64PostLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64PostLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64PostLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset AArch64PostLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void AArch64PostLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64PostLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AArch64PostLegalizerCombinerImpl::ComplexMatcherMemFn
AArch64PostLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
};
bool AArch64PostLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PostLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
};

bool AArch64PostLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AArch64PostLegalizerCombinerImpl::CustomRendererFn
AArch64PostLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AArch64PostLegalizerCombinerImpl::tryCombineAll(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
};
bool AArch64PostLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantSextInReg(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    // Match Patterns
    if(![&](){return matchMutateAnyExtToZExt(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyMutateAnyExtToZExt(*State.MIs[0], MRI, B, Observer);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    IndexedLoadStoreMatchInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineIndexedLoadStore(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineIndexedLoadStore(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    // Match Patterns
    if(![&](){return Helper.matchSextTruncSextLoad(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextTruncSextLoad(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::tuple<unsigned, LLT, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtractVecEltPairwiseAdd(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtractVecEltPairwiseAdd(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder&, Register)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchAArch64MulConstCombine(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyAArch64MulConstCombine(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    // Match Patterns
    if(![&](){return Helper.matchRotateOutOfRange(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyRotateOutOfRange(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    // Match Patterns
    if(![&](){return matchFoldMergeToZext(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyFoldMergeToZext(*State.MIs[0], MRI, B, Observer);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    // Match Patterns
    if(![&](){return matchSplitStoreZero128(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applySplitStoreZero128(*State.MIs[0], MRI, B, Observer);
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchOrToBSP(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyOrToBSP(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCombineMulCMLT(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyCombineMulCMLT(*State.MIs[0], MRI, B, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    std::tuple<bool, Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtMulToMULL(*State.MIs[0], MRI, VT, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtMulToMULL(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64PostLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(239), /*)*//*default:*//*Label 75*/ GIMT_Encode4(3604),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(886), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(898),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1023),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(1069),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(1182),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(1205),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(1239),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(1262), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(1296),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(1435),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(1549), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(1628), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(1695),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 13*/ GIMT_Encode4(1780),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 14*/ GIMT_Encode4(1817),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 15*/ GIMT_Encode4(1829),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 16*/ GIMT_Encode4(1841),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 17*/ GIMT_Encode4(1884),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 18*/ GIMT_Encode4(1917),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 19*/ GIMT_Encode4(1960), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 20*/ GIMT_Encode4(1972),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 21*/ GIMT_Encode4(1995),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 22*/ GIMT_Encode4(2018), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 23*/ GIMT_Encode4(2041), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  462 */ /*TargetOpcode::G_ANYEXT*//*Label 24*/ GIMT_Encode4(2075),
     /*  466 */ /*TargetOpcode::G_TRUNC*//*Label 25*/ GIMT_Encode4(2182), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  486 */ /*TargetOpcode::G_SEXT*//*Label 26*/ GIMT_Encode4(2334),
     /*  490 */ /*TargetOpcode::G_SEXT_INREG*//*Label 27*/ GIMT_Encode4(2377),
     /*  494 */ /*TargetOpcode::G_ZEXT*//*Label 28*/ GIMT_Encode4(2432),
     /*  498 */ /*TargetOpcode::G_SHL*//*Label 29*/ GIMT_Encode4(2475),
     /*  502 */ /*TargetOpcode::G_LSHR*//*Label 30*/ GIMT_Encode4(2543),
     /*  506 */ /*TargetOpcode::G_ASHR*//*Label 31*/ GIMT_Encode4(2622), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  518 */ /*TargetOpcode::G_ROTR*//*Label 32*/ GIMT_Encode4(2701),
     /*  522 */ /*TargetOpcode::G_ROTL*//*Label 33*/ GIMT_Encode4(2736),
     /*  526 */ /*TargetOpcode::G_ICMP*//*Label 34*/ GIMT_Encode4(2771), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  542 */ /*TargetOpcode::G_SELECT*//*Label 35*/ GIMT_Encode4(2783),
     /*  546 */ /*TargetOpcode::G_UADDO*//*Label 36*/ GIMT_Encode4(2878), GIMT_Encode4(0),
     /*  554 */ /*TargetOpcode::G_USUBO*//*Label 37*/ GIMT_Encode4(2901), GIMT_Encode4(0),
     /*  562 */ /*TargetOpcode::G_SADDO*//*Label 38*/ GIMT_Encode4(2913), GIMT_Encode4(0),
     /*  570 */ /*TargetOpcode::G_SSUBO*//*Label 39*/ GIMT_Encode4(2936), GIMT_Encode4(0),
     /*  578 */ /*TargetOpcode::G_UMULO*//*Label 40*/ GIMT_Encode4(2948),
     /*  582 */ /*TargetOpcode::G_SMULO*//*Label 41*/ GIMT_Encode4(2960),
     /*  586 */ /*TargetOpcode::G_UMULH*//*Label 42*/ GIMT_Encode4(2972),
     /*  590 */ /*TargetOpcode::G_SMULH*//*Label 43*/ GIMT_Encode4(2984),
     /*  594 */ /*TargetOpcode::G_UADDSAT*//*Label 44*/ GIMT_Encode4(2996),
     /*  598 */ /*TargetOpcode::G_SADDSAT*//*Label 45*/ GIMT_Encode4(3008), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  618 */ /*TargetOpcode::G_SMULFIX*//*Label 46*/ GIMT_Encode4(3020),
     /*  622 */ /*TargetOpcode::G_UMULFIX*//*Label 47*/ GIMT_Encode4(3032),
     /*  626 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 48*/ GIMT_Encode4(3044),
     /*  630 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 49*/ GIMT_Encode4(3056), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  650 */ /*TargetOpcode::G_FADD*//*Label 50*/ GIMT_Encode4(3068),
     /*  654 */ /*TargetOpcode::G_FSUB*//*Label 51*/ GIMT_Encode4(3114),
     /*  658 */ /*TargetOpcode::G_FMUL*//*Label 52*/ GIMT_Encode4(3126), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  670 */ /*TargetOpcode::G_FDIV*//*Label 53*/ GIMT_Encode4(3192), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  718 */ /*TargetOpcode::G_FNEG*//*Label 54*/ GIMT_Encode4(3204), GIMT_Encode4(0),
     /*  726 */ /*TargetOpcode::G_FPTRUNC*//*Label 55*/ GIMT_Encode4(3234),
     /*  730 */ /*TargetOpcode::G_FPTOSI*//*Label 56*/ GIMT_Encode4(3256),
     /*  734 */ /*TargetOpcode::G_FPTOUI*//*Label 57*/ GIMT_Encode4(3278),
     /*  738 */ /*TargetOpcode::G_SITOFP*//*Label 58*/ GIMT_Encode4(3300),
     /*  742 */ /*TargetOpcode::G_UITOFP*//*Label 59*/ GIMT_Encode4(3312), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  770 */ /*TargetOpcode::G_FMINNUM*//*Label 60*/ GIMT_Encode4(3324),
     /*  774 */ /*TargetOpcode::G_FMAXNUM*//*Label 61*/ GIMT_Encode4(3336),
     /*  778 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 62*/ GIMT_Encode4(3348),
     /*  782 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 63*/ GIMT_Encode4(3360),
     /*  786 */ /*TargetOpcode::G_FMINIMUM*//*Label 64*/ GIMT_Encode4(3372),
     /*  790 */ /*TargetOpcode::G_FMAXIMUM*//*Label 65*/ GIMT_Encode4(3384), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  818 */ /*TargetOpcode::G_PTR_ADD*//*Label 66*/ GIMT_Encode4(3396), GIMT_Encode4(0),
     /*  826 */ /*TargetOpcode::G_SMIN*//*Label 67*/ GIMT_Encode4(3442),
     /*  830 */ /*TargetOpcode::G_SMAX*//*Label 68*/ GIMT_Encode4(3465),
     /*  834 */ /*TargetOpcode::G_UMIN*//*Label 69*/ GIMT_Encode4(3488),
     /*  838 */ /*TargetOpcode::G_UMAX*//*Label 70*/ GIMT_Encode4(3511),
     /*  842 */ /*TargetOpcode::G_ABS*//*Label 71*/ GIMT_Encode4(3534), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  874 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 72*/ GIMT_Encode4(3546),
     /*  878 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 73*/ GIMT_Encode4(3558),
     /*  882 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 74*/ GIMT_Encode4(3581),
     /*  886 */ // Label 0: @886
     /*  886 */ GIM_Try, /*On fail goto*//*Label 76*/ GIMT_Encode4(897), // Rule ID 0 //
     /*  891 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /*  894 */   // MIs[0] d
     /*  894 */   // No operand predicates
     /*  894 */   // MIs[0] s
     /*  894 */   // No operand predicates
     /*  894 */   // Combiner Rule #0: copy_prop
     /*  894 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /*  897 */ // Label 76: @897
     /*  897 */ GIM_Reject,
     /*  898 */ // Label 1: @898
     /*  898 */ GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(909), // Rule ID 60 //
     /*  903 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /*  906 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_ADD'
     /*  906 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /*  909 */ // Label 77: @909
     /*  909 */ GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(920), // Rule ID 141 //
     /*  914 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /*  917 */   // Combiner Rule #79: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /*  917 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /*  920 */ // Label 78: @920
     /*  920 */ GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(931), // Rule ID 153 //
     /*  925 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /*  928 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /*  928 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /*  931 */ // Label 79: @931
     /*  931 */ GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(965), // Rule ID 110 //
     /*  936 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /*  939 */   // MIs[0] dst
     /*  939 */   // No operand predicates
     /*  939 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  939 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  947 */   // MIs[1] src
     /*  947 */   // No operand predicates
     /*  947 */   // MIs[1] __add_sub_reg_match_0.x
     /*  947 */   // No operand predicates
     /*  947 */   // MIs[0] __add_sub_reg_match_0.x
     /*  947 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  952 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  957 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959 */   // Combiner Rule #61: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /*  959 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  964 */   GIR_EraseRootFromParent_Done,
     /*  965 */ // Label 80: @965
     /*  965 */ GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(999), // Rule ID 109 //
     /*  970 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /*  973 */   // MIs[0] dst
     /*  973 */   // No operand predicates
     /*  973 */   // MIs[0] __add_sub_reg_match_0.x
     /*  973 */   // No operand predicates
     /*  973 */   // MIs[0] __add_sub_reg_match_0.tmp
     /*  973 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  981 */   // MIs[1] src
     /*  981 */   // No operand predicates
     /*  981 */   // MIs[1] __add_sub_reg_match_0.x
     /*  981 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  986 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  991 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  993 */   // Combiner Rule #61: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /*  993 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /*  998 */   GIR_EraseRootFromParent_Done,
     /*  999 */ // Label 81: @999
     /*  999 */ GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1022), // Rule ID 84 //
     /* 1004 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1007 */   // MIs[0] dst
     /* 1007 */   // No operand predicates
     /* 1007 */   // MIs[0] lhs
     /* 1007 */   // No operand predicates
     /* 1007 */   // MIs[0] Operand 2
     /* 1007 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1011 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1016 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1016 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1021 */   GIR_EraseRootFromParent_Done,
     /* 1022 */ // Label 82: @1022
     /* 1022 */ GIM_Reject,
     /* 1023 */ // Label 2: @1023
     /* 1023 */ GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1034), // Rule ID 68 //
     /* 1028 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1031 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1031 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1034 */ // Label 83: @1034
     /* 1034 */ GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1045), // Rule ID 142 //
     /* 1039 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 1042 */   // Combiner Rule #79: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1042 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 1045 */ // Label 84: @1045
     /* 1045 */ GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1068), // Rule ID 83 //
     /* 1050 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1053 */   // MIs[0] dst
     /* 1053 */   // No operand predicates
     /* 1053 */   // MIs[0] lhs
     /* 1053 */   // No operand predicates
     /* 1053 */   // MIs[0] Operand 2
     /* 1053 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1057 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1062 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 1062 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1067 */   GIR_EraseRootFromParent_Done,
     /* 1068 */ // Label 85: @1068
     /* 1068 */ GIM_Reject,
     /* 1069 */ // Label 3: @1069
     /* 1069 */ GIM_Try, /*On fail goto*//*Label 86*/ GIMT_Encode4(1080), // Rule ID 31 //
     /* 1074 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 1077 */   // Combiner Rule #24: mul_const; wip_match_opcode 'G_MUL'
     /* 1077 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 1080 */ // Label 86: @1080
     /* 1080 */ GIM_Try, /*On fail goto*//*Label 87*/ GIMT_Encode4(1091), // Rule ID 65 //
     /* 1085 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1088 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 1088 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1091 */ // Label 87: @1091
     /* 1091 */ GIM_Try, /*On fail goto*//*Label 88*/ GIMT_Encode4(1102), // Rule ID 125 //
     /* 1096 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 1099 */   // Combiner Rule #73: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 1099 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1102 */ // Label 88: @1102
     /* 1102 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1113), // Rule ID 154 //
     /* 1107 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1110 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 1110 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1113 */ // Label 89: @1113
     /* 1113 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1124), // Rule ID 183 //
     /* 1118 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 1121 */   // Combiner Rule #90: combine_mul_cmlt; wip_match_opcode 'G_MUL'
     /* 1121 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 1124 */ // Label 90: @1124
     /* 1124 */ GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1147), // Rule ID 102 //
     /* 1129 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 1132 */   // MIs[0] dst
     /* 1132 */   // No operand predicates
     /* 1132 */   // MIs[0] lhs
     /* 1132 */   // No operand predicates
     /* 1132 */   // MIs[0] zero
     /* 1132 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1136 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1141 */   // Combiner Rule #54: binop_right_to_zero
     /* 1141 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1146 */   GIR_EraseRootFromParent_Done,
     /* 1147 */ // Label 91: @1147
     /* 1147 */ GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1170), // Rule ID 107 //
     /* 1152 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 1155 */   // MIs[0] dst
     /* 1155 */   // No operand predicates
     /* 1155 */   // MIs[0] x
     /* 1155 */   // No operand predicates
     /* 1155 */   // MIs[0] Operand 2
     /* 1155 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 1159 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1164 */   // Combiner Rule #59: right_identity_one_int
     /* 1164 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1169 */   GIR_EraseRootFromParent_Done,
     /* 1170 */ // Label 92: @1170
     /* 1170 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1181), // Rule ID 185 //
     /* 1175 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 1178 */   // MIs[0] dst
     /* 1178 */   // No operand predicates
     /* 1178 */   // MIs[0] src1
     /* 1178 */   // No operand predicates
     /* 1178 */   // MIs[0] src2
     /* 1178 */   // No operand predicates
     /* 1178 */   // Combiner Rule #92: extmultomull
     /* 1178 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 1181 */ // Label 93: @1181
     /* 1181 */ GIM_Reject,
     /* 1182 */ // Label 4: @1182
     /* 1182 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1193), // Rule ID 71 //
     /* 1187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1190 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 1190 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1193 */ // Label 94: @1193
     /* 1193 */ GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1204), // Rule ID 98 //
     /* 1198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1201 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 1201 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1204 */ // Label 95: @1204
     /* 1204 */ GIM_Reject,
     /* 1205 */ // Label 5: @1205
     /* 1205 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1216), // Rule ID 70 //
     /* 1210 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1213 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 1213 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1216 */ // Label 96: @1216
     /* 1216 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1227), // Rule ID 99 //
     /* 1221 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1224 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 1224 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1227 */ // Label 97: @1227
     /* 1227 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1238), // Rule ID 128 //
     /* 1232 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 1235 */   // Combiner Rule #75: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 1235 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 1238 */ // Label 98: @1238
     /* 1238 */ GIM_Reject,
     /* 1239 */ // Label 6: @1239
     /* 1239 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1250), // Rule ID 73 //
     /* 1244 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1247 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 1247 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1250 */ // Label 99: @1250
     /* 1250 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1261), // Rule ID 100 //
     /* 1255 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1258 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 1258 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1261 */ // Label 100: @1261
     /* 1261 */ GIM_Reject,
     /* 1262 */ // Label 7: @1262
     /* 1262 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1273), // Rule ID 72 //
     /* 1267 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1270 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 1270 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1273 */ // Label 101: @1273
     /* 1273 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1284), // Rule ID 101 //
     /* 1278 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 1281 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 1281 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 1284 */ // Label 102: @1284
     /* 1284 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1295), // Rule ID 129 //
     /* 1289 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 1292 */   // Combiner Rule #75: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 1292 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 1295 */ // Label 103: @1295
     /* 1295 */ GIM_Reject,
     /* 1296 */ // Label 8: @1296
     /* 1296 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1307), // Rule ID 18 //
     /* 1301 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1304 */   // Combiner Rule #16: load_and_mask; wip_match_opcode 'G_AND'
     /* 1304 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1307 */ // Label 104: @1307
     /* 1307 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1318), // Rule ID 24 //
     /* 1312 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1315 */   // Combiner Rule #19: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 1315 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1318 */ // Label 105: @1318
     /* 1318 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1329), // Rule ID 27 //
     /* 1323 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 1326 */   // Combiner Rule #20: redundant_and; wip_match_opcode 'G_AND'
     /* 1326 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 1329 */ // Label 106: @1329
     /* 1329 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1340), // Rule ID 62 //
     /* 1334 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1337 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 1337 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1340 */ // Label 107: @1340
     /* 1340 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1351), // Rule ID 120 //
     /* 1345 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 1348 */   // Combiner Rule #70: overlapping_and; wip_match_opcode 'G_AND'
     /* 1348 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 1351 */ // Label 108: @1351
     /* 1351 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1362), // Rule ID 124 //
     /* 1356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 1359 */   // Combiner Rule #73: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 1359 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1362 */ // Label 109: @1362
     /* 1362 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1373), // Rule ID 155 //
     /* 1367 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1370 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 1370 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1373 */ // Label 110: @1373
     /* 1373 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1410), // Rule ID 34 //
     /* 1378 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 1381 */   // MIs[0] root
     /* 1381 */   // No operand predicates
     /* 1381 */   // MIs[0] shift
     /* 1381 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1385 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 1389 */   // MIs[1] x
     /* 1389 */   // No operand predicates
     /* 1389 */   // MIs[1] lsb
     /* 1389 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1393 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1397 */   // MIs[2] imm1
     /* 1397 */   // No operand predicates
     /* 1397 */   // MIs[0] mask
     /* 1397 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1401 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1405 */   // MIs[3] imm2
     /* 1405 */   // No operand predicates
     /* 1405 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1407 */   // Combiner Rule #27: bitfield_extract_from_and
     /* 1407 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 1410 */ // Label 111: @1410
     /* 1410 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1434), // Rule ID 93 //
     /* 1415 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 1418 */   // MIs[0] dst
     /* 1418 */   // No operand predicates
     /* 1418 */   // MIs[0] src
     /* 1418 */   // No operand predicates
     /* 1418 */   // MIs[0] src
     /* 1418 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1423 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1428 */   // Combiner Rule #52: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 1428 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1433 */   GIR_EraseRootFromParent_Done,
     /* 1434 */ // Label 112: @1434
     /* 1434 */ GIM_Reject,
     /* 1435 */ // Label 9: @1435
     /* 1435 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1446), // Rule ID 25 //
     /* 1440 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1443 */   // Combiner Rule #19: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 1443 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1446 */ // Label 113: @1446
     /* 1446 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1457), // Rule ID 30 //
     /* 1451 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 1454 */   // Combiner Rule #23: redundant_or; wip_match_opcode 'G_OR'
     /* 1454 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1457 */ // Label 114: @1457
     /* 1457 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1468), // Rule ID 66 //
     /* 1462 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1465 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 1465 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1468 */ // Label 115: @1468
     /* 1468 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1479), // Rule ID 126 //
     /* 1473 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 1476 */   // Combiner Rule #74: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 1476 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 1479 */ // Label 116: @1479
     /* 1479 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1490), // Rule ID 156 //
     /* 1484 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1487 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 1487 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1490 */ // Label 117: @1490
     /* 1490 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1514), // Rule ID 94 //
     /* 1495 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 1498 */   // MIs[0] dst
     /* 1498 */   // No operand predicates
     /* 1498 */   // MIs[0] src
     /* 1498 */   // No operand predicates
     /* 1498 */   // MIs[0] src
     /* 1498 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1503 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1508 */   // Combiner Rule #52: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 1508 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1513 */   GIR_EraseRootFromParent_Done,
     /* 1514 */ // Label 118: @1514
     /* 1514 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1537), // Rule ID 85 //
     /* 1519 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1522 */   // MIs[0] dst
     /* 1522 */   // No operand predicates
     /* 1522 */   // MIs[0] lhs
     /* 1522 */   // No operand predicates
     /* 1522 */   // MIs[0] Operand 2
     /* 1522 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1526 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1531 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 1531 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1536 */   GIR_EraseRootFromParent_Done,
     /* 1537 */ // Label 119: @1537
     /* 1537 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1548), // Rule ID 151 //
     /* 1542 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 1545 */   // MIs[0] dst
     /* 1545 */   // No operand predicates
     /* 1545 */   // MIs[0] src1
     /* 1545 */   // No operand predicates
     /* 1545 */   // MIs[0] src2
     /* 1545 */   // No operand predicates
     /* 1545 */   // Combiner Rule #85: or_to_bsp
     /* 1545 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 1548 */ // Label 120: @1548
     /* 1548 */ GIM_Reject,
     /* 1549 */ // Label 10: @1549
     /* 1549 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1560), // Rule ID 26 //
     /* 1554 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 1557 */   // Combiner Rule #19: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 1557 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 1560 */ // Label 121: @1560
     /* 1560 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1571), // Rule ID 28 //
     /* 1565 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 1568 */   // Combiner Rule #21: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 1568 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 1571 */ // Label 122: @1571
     /* 1571 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1582), // Rule ID 69 //
     /* 1576 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 1579 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 1579 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1582 */ // Label 123: @1582
     /* 1582 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1593), // Rule ID 143 //
     /* 1587 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 1590 */   // Combiner Rule #79: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 1590 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 1593 */ // Label 124: @1593
     /* 1593 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1604), // Rule ID 157 //
     /* 1598 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1601 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 1601 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 1604 */ // Label 125: @1604
     /* 1604 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1627), // Rule ID 86 //
     /* 1609 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 1612 */   // MIs[0] dst
     /* 1612 */   // No operand predicates
     /* 1612 */   // MIs[0] lhs
     /* 1612 */   // No operand predicates
     /* 1612 */   // MIs[0] Operand 2
     /* 1612 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1616 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1621 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 1621 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1626 */   GIR_EraseRootFromParent_Done,
     /* 1627 */ // Label 126: @1627
     /* 1627 */ GIM_Reject,
     /* 1628 */ // Label 11: @1628
     /* 1628 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1639), // Rule ID 51 //
     /* 1633 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 1636 */   // Combiner Rule #39: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1636 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 1639 */ // Label 127: @1639
     /* 1639 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1650), // Rule ID 52 //
     /* 1644 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 1647 */   // Combiner Rule #40: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1647 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 1650 */ // Label 128: @1650
     /* 1650 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1661), // Rule ID 54 //
     /* 1655 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 1658 */   // Combiner Rule #42: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1658 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 1661 */ // Label 129: @1661
     /* 1661 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1672), // Rule ID 55 //
     /* 1666 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 1669 */   // Combiner Rule #43: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1669 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 1672 */ // Label 130: @1672
     /* 1672 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1683), // Rule ID 56 //
     /* 1677 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 1680 */   // Combiner Rule #44: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1680 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 1683 */ // Label 131: @1683
     /* 1683 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1694), // Rule ID 57 //
     /* 1688 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 1691 */   // Combiner Rule #45: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 1691 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 1694 */ // Label 132: @1694
     /* 1694 */ GIM_Reject,
     /* 1695 */ // Label 12: @1695
     /* 1695 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1706), // Rule ID 50 //
     /* 1700 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 1703 */   // Combiner Rule #38: fold_merge_to_zext; wip_match_opcode 'G_MERGE_VALUES'
     /* 1703 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 1706 */ // Label 133: @1706
     /* 1706 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1717), // Rule ID 53 //
     /* 1711 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 1714 */   // Combiner Rule #41: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 1714 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 1717 */ // Label 134: @1717
     /* 1717 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(1779),
     /* 1722 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 1725 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(1746), // Rule ID 58 //
     /* 1730 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 1733 */     // MIs[0] root
     /* 1733 */     // No operand predicates
     /* 1733 */     // MIs[0] x
     /* 1733 */     // No operand predicates
     /* 1733 */     // MIs[0] undef
     /* 1733 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1743 */     // Combiner Rule #46: merge_of_x_and_undef
     /* 1743 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 1746 */   // Label 136: @1746
     /* 1746 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(1778), // Rule ID 59 //
     /* 1751 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 1754 */     // MIs[0] root
     /* 1754 */     // No operand predicates
     /* 1754 */     // MIs[0] x
     /* 1754 */     // No operand predicates
     /* 1754 */     // MIs[0] zero
     /* 1754 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1762 */     // MIs[1] Operand 1
     /* 1762 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 1773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1775 */     // Combiner Rule #47: merge_of_x_and_zero
     /* 1775 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 1778 */   // Label 137: @1778
     /* 1778 */   GIM_Reject,
     /* 1779 */ // Label 135: @1779
     /* 1779 */ GIM_Reject,
     /* 1780 */ // Label 13: @1780
     /* 1780 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(1791), // Rule ID 112 //
     /* 1785 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 1788 */   // Combiner Rule #62: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1788 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 1791 */ // Label 138: @1791
     /* 1791 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(1802), // Rule ID 145 //
     /* 1796 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 1799 */   // Combiner Rule #80: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 1799 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 1802 */ // Label 139: @1802
     /* 1802 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(1816), // Rule ID 184 //
     /* 1807 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 1810 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 1813 */   // MIs[0] dst
     /* 1813 */   // No operand predicates
     /* 1813 */   // MIs[0] unused
     /* 1813 */   // No operand predicates
     /* 1813 */   // Combiner Rule #91: combine_use_vector_truncate
     /* 1813 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 1816 */ // Label 140: @1816
     /* 1816 */ GIM_Reject,
     /* 1817 */ // Label 14: @1817
     /* 1817 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(1828), // Rule ID 111 //
     /* 1822 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 1825 */   // Combiner Rule #62: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 1825 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 1828 */ // Label 141: @1828
     /* 1828 */ GIM_Reject,
     /* 1829 */ // Label 15: @1829
     /* 1829 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(1840), // Rule ID 152 //
     /* 1834 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 1837 */   // Combiner Rule #86: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 1837 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 1840 */ // Label 142: @1840
     /* 1840 */ GIM_Reject,
     /* 1841 */ // Label 16: @1841
     /* 1841 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(1862), // Rule ID 104 //
     /* 1846 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 1849 */   // MIs[0] dst
     /* 1849 */   // No operand predicates
     /* 1849 */   // MIs[0] t
     /* 1849 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1853 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 1857 */   // MIs[1] ptr
     /* 1857 */   // No operand predicates
     /* 1857 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1859 */   // Combiner Rule #56: i2p_to_p2i
     /* 1859 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 1862 */ // Label 143: @1862
     /* 1862 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(1883), // Rule ID 137 //
     /* 1867 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1870 */   // MIs[0] dst
     /* 1870 */   // No operand predicates
     /* 1870 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 1870 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1874 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1878 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1880 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 1880 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1883 */ // Label 144: @1883
     /* 1883 */ GIM_Reject,
     /* 1884 */ // Label 17: @1884
     /* 1884 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(1895), // Rule ID 103 //
     /* 1889 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 1892 */   // Combiner Rule #55: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 1892 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 1895 */ // Label 145: @1895
     /* 1895 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(1916), // Rule ID 138 //
     /* 1900 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1903 */   // MIs[0] dst
     /* 1903 */   // No operand predicates
     /* 1903 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 1903 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1907 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1913 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 1913 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1916 */ // Label 146: @1916
     /* 1916 */ GIM_Reject,
     /* 1917 */ // Label 18: @1917
     /* 1917 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(1938), // Rule ID 115 //
     /* 1922 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 1925 */   // MIs[0] dst
     /* 1925 */   // No operand predicates
     /* 1925 */   // MIs[0] src1
     /* 1925 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1929 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 1933 */   // MIs[1] src0
     /* 1933 */   // No operand predicates
     /* 1933 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1935 */   // Combiner Rule #65: bitcast_bitcast_fold
     /* 1935 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 1938 */ // Label 147: @1938
     /* 1938 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(1959), // Rule ID 135 //
     /* 1943 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1946 */   // MIs[0] dst
     /* 1946 */   // No operand predicates
     /* 1946 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 1946 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 1954 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1956 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 1956 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1959 */ // Label 148: @1959
     /* 1959 */ GIM_Reject,
     /* 1960 */ // Label 19: @1960
     /* 1960 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(1971), // Rule ID 182 //
     /* 1965 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 1968 */   // MIs[0] dst
     /* 1968 */   // No operand predicates
     /* 1968 */   // MIs[0] src
     /* 1968 */   // No operand predicates
     /* 1968 */   // Combiner Rule #89: push_freeze_to_prevent_poison_from_propagating
     /* 1968 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 1971 */ // Label 149: @1971
     /* 1971 */ GIM_Reject,
     /* 1972 */ // Label 20: @1972
     /* 1972 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(1983), // Rule ID 15 //
     /* 1977 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 1980 */   // Combiner Rule #15: extending_loads; wip_match_opcode 'G_LOAD'
     /* 1980 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 1983 */ // Label 150: @1983
     /* 1983 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(1994), // Rule ID 19 //
     /* 1988 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 1991 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_LOAD'
     /* 1991 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 1994 */ // Label 151: @1994
     /* 1994 */ GIM_Reject,
     /* 1995 */ // Label 21: @1995
     /* 1995 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2006), // Rule ID 16 //
     /* 2000 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2003 */   // Combiner Rule #15: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 2003 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2006 */ // Label 152: @2006
     /* 2006 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2017), // Rule ID 20 //
     /* 2011 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2014 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_SEXTLOAD'
     /* 2014 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 2017 */ // Label 153: @2017
     /* 2017 */ GIM_Reject,
     /* 2018 */ // Label 22: @2018
     /* 2018 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2029), // Rule ID 17 //
     /* 2023 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2026 */   // Combiner Rule #15: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 2026 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2029 */ // Label 154: @2029
     /* 2029 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2040), // Rule ID 21 //
     /* 2034 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2037 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_ZEXTLOAD'
     /* 2037 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 2040 */ // Label 155: @2040
     /* 2040 */ GIM_Reject,
     /* 2041 */ // Label 23: @2041
     /* 2041 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2052), // Rule ID 22 //
     /* 2046 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2049 */   // Combiner Rule #17: combine_indexed_load_store; wip_match_opcode 'G_STORE'
     /* 2049 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 2052 */ // Label 156: @2052
     /* 2052 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2063), // Rule ID 147 //
     /* 2057 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 2060 */   // Combiner Rule #82: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 2060 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 2063 */ // Label 157: @2063
     /* 2063 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2074), // Rule ID 121 //
     /* 2068 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 2071 */   // MIs[0] src
     /* 2071 */   // No operand predicates
     /* 2071 */   // MIs[0] addr
     /* 2071 */   // No operand predicates
     /* 2071 */   // Combiner Rule #71: split_store_zero_128
     /* 2071 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 2074 */ // Label 158: @2074
     /* 2074 */ GIM_Reject,
     /* 2075 */ // Label 24: @2075
     /* 2075 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2086), // Rule ID 14 //
     /* 2080 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2083 */   // Combiner Rule #14: mutate_anyext_to_zext; wip_match_opcode 'G_ANYEXT'
     /* 2083 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2086 */ // Label 159: @2086
     /* 2086 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2097), // Rule ID 105 //
     /* 2091 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 2094 */   // Combiner Rule #57: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 2094 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2097 */ // Label 160: @2097
     /* 2097 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2118), // Rule ID 8 //
     /* 2102 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 2105 */   // MIs[0] root
     /* 2105 */   // No operand predicates
     /* 2105 */   // MIs[0] second
     /* 2105 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2109 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2113 */   // MIs[1] src
     /* 2113 */   // No operand predicates
     /* 2113 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2115 */   // Combiner Rule #8: anyext_of_anyext
     /* 2115 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2118 */ // Label 161: @2118
     /* 2118 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2139), // Rule ID 10 //
     /* 2123 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 2126 */   // MIs[0] root
     /* 2126 */   // No operand predicates
     /* 2126 */   // MIs[0] second
     /* 2126 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2130 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2134 */   // MIs[1] src
     /* 2134 */   // No operand predicates
     /* 2134 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2136 */   // Combiner Rule #10: anyext_of_sext
     /* 2136 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2139 */ // Label 162: @2139
     /* 2139 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2160), // Rule ID 9 //
     /* 2144 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 2147 */   // MIs[0] root
     /* 2147 */   // No operand predicates
     /* 2147 */   // MIs[0] second
     /* 2147 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2151 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2155 */   // MIs[1] src
     /* 2155 */   // No operand predicates
     /* 2155 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2157 */   // Combiner Rule #9: anyext_of_zext
     /* 2157 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2160 */ // Label 163: @2160
     /* 2160 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2181), // Rule ID 136 //
     /* 2165 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 2168 */   // MIs[0] dst
     /* 2168 */   // No operand predicates
     /* 2168 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 2168 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 2176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2178 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 2178 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 2181 */ // Label 164: @2181
     /* 2181 */ GIM_Reject,
     /* 2182 */ // Label 25: @2182
     /* 2182 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2193), // Rule ID 113 //
     /* 2187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 2190 */   // Combiner Rule #63: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 2190 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 2193 */ // Label 165: @2193
     /* 2193 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2204), // Rule ID 114 //
     /* 2198 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 2201 */   // Combiner Rule #64: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 2201 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 2204 */ // Label 166: @2204
     /* 2204 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2225), // Rule ID 3 //
     /* 2209 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 2212 */   // MIs[0] root
     /* 2212 */   // No operand predicates
     /* 2212 */   // MIs[0] ext
     /* 2212 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2220 */   // MIs[1] src
     /* 2220 */   // No operand predicates
     /* 2220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2222 */   // Combiner Rule #3: truncate_of_anyext
     /* 2222 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2225 */ // Label 167: @2225
     /* 2225 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2249), // Rule ID 12 //
     /* 2230 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 2233 */   // MIs[0] root
     /* 2233 */   // No operand predicates
     /* 2233 */   // MIs[0] bv
     /* 2233 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 2241 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 2244 */   // MIs[1] unused
     /* 2244 */   // No operand predicates
     /* 2244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2246 */   // Combiner Rule #12: buildvector_of_truncate
     /* 2246 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 2249 */ // Label 168: @2249
     /* 2249 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2270), // Rule ID 2 //
     /* 2254 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 2257 */   // MIs[0] root
     /* 2257 */   // No operand predicates
     /* 2257 */   // MIs[0] ext
     /* 2257 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2265 */   // MIs[1] src
     /* 2265 */   // No operand predicates
     /* 2265 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2267 */   // Combiner Rule #2: truncate_of_sext
     /* 2267 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2270 */ // Label 169: @2270
     /* 2270 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2291), // Rule ID 1 //
     /* 2275 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 2278 */   // MIs[0] root
     /* 2278 */   // No operand predicates
     /* 2278 */   // MIs[0] ext
     /* 2278 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2282 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2286 */   // MIs[1] src
     /* 2286 */   // No operand predicates
     /* 2286 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288 */   // Combiner Rule #1: truncate_of_zext
     /* 2288 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2291 */ // Label 170: @2291
     /* 2291 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2312), // Rule ID 134 //
     /* 2296 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 2299 */   // MIs[0] dst
     /* 2299 */   // No operand predicates
     /* 2299 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 2299 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 2307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 2309 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 2312 */ // Label 171: @2312
     /* 2312 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2333), // Rule ID 13 //
     /* 2317 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 2320 */   // MIs[0] root
     /* 2320 */   // No operand predicates
     /* 2320 */   // MIs[0] int
     /* 2320 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2328 */   // MIs[1] imm
     /* 2328 */   // No operand predicates
     /* 2328 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2330 */   // Combiner Rule #13: integer_of_truncate
     /* 2330 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 2333 */ // Label 172: @2333
     /* 2333 */ GIM_Reject,
     /* 2334 */ // Label 26: @2334
     /* 2334 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2355), // Rule ID 7 //
     /* 2339 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 2342 */   // MIs[0] root
     /* 2342 */   // No operand predicates
     /* 2342 */   // MIs[0] second
     /* 2342 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2346 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2350 */   // MIs[1] src
     /* 2350 */   // No operand predicates
     /* 2350 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352 */   // Combiner Rule #7: sext_of_anyext
     /* 2352 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2355 */ // Label 173: @2355
     /* 2355 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2376), // Rule ID 6 //
     /* 2360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 2363 */   // MIs[0] root
     /* 2363 */   // No operand predicates
     /* 2363 */   // MIs[0] second
     /* 2363 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2371 */   // MIs[1] src
     /* 2371 */   // No operand predicates
     /* 2371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2373 */   // Combiner Rule #6: sext_of_sext
     /* 2373 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2376 */ // Label 174: @2376
     /* 2376 */ GIM_Reject,
     /* 2377 */ // Label 27: @2377
     /* 2377 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2388), // Rule ID 23 //
     /* 2382 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 2385 */   // Combiner Rule #18: sext_trunc_sextload; wip_match_opcode 'G_SEXT_INREG'
     /* 2385 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 2388 */ // Label 175: @2388
     /* 2388 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2399), // Rule ID 32 //
     /* 2393 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 2396 */   // Combiner Rule #25: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 2396 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 2399 */ // Label 176: @2399
     /* 2399 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2410), // Rule ID 33 //
     /* 2404 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 2407 */   // Combiner Rule #26: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 2407 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 2410 */ // Label 177: @2410
     /* 2410 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2431), // Rule ID 11 //
     /* 2415 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 2418 */   // MIs[0] dst
     /* 2418 */   // No operand predicates
     /* 2418 */   // MIs[0] x
     /* 2418 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2422 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2426 */   // MIs[1] src
     /* 2426 */   // No operand predicates
     /* 2426 */   // MIs[1] a
     /* 2426 */   // No operand predicates
     /* 2426 */   // MIs[0] b
     /* 2426 */   // No operand predicates
     /* 2426 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428 */   // Combiner Rule #11: sext_inreg_of_sext_inreg
     /* 2428 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 2431 */ // Label 178: @2431
     /* 2431 */ GIM_Reject,
     /* 2432 */ // Label 28: @2432
     /* 2432 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2453), // Rule ID 5 //
     /* 2437 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 2440 */   // MIs[0] root
     /* 2440 */   // No operand predicates
     /* 2440 */   // MIs[0] second
     /* 2440 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2444 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 2448 */   // MIs[1] src
     /* 2448 */   // No operand predicates
     /* 2448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450 */   // Combiner Rule #5: zext_of_anyext
     /* 2450 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2453 */ // Label 179: @2453
     /* 2453 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2474), // Rule ID 4 //
     /* 2458 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 2461 */   // MIs[0] root
     /* 2461 */   // No operand predicates
     /* 2461 */   // MIs[0] second
     /* 2461 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2465 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2469 */   // MIs[1] src
     /* 2469 */   // No operand predicates
     /* 2469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2471 */   // Combiner Rule #4: zext_of_zext
     /* 2471 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 2474 */ // Label 180: @2474
     /* 2474 */ GIM_Reject,
     /* 2475 */ // Label 29: @2475
     /* 2475 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2486), // Rule ID 67 //
     /* 2480 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 2483 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 2483 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2486 */ // Label 181: @2486
     /* 2486 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2497), // Rule ID 95 //
     /* 2491 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 2494 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 2494 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 2497 */ // Label 182: @2497
     /* 2497 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2508), // Rule ID 127 //
     /* 2502 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 2505 */   // Combiner Rule #75: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 2505 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 2508 */ // Label 183: @2508
     /* 2508 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2519), // Rule ID 130 //
     /* 2513 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 2516 */   // Combiner Rule #76: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 2516 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 2519 */ // Label 184: @2519
     /* 2519 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2542), // Rule ID 87 //
     /* 2524 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2527 */   // MIs[0] dst
     /* 2527 */   // No operand predicates
     /* 2527 */   // MIs[0] lhs
     /* 2527 */   // No operand predicates
     /* 2527 */   // MIs[0] Operand 2
     /* 2527 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2531 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2536 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 2536 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2541 */   GIR_EraseRootFromParent_Done,
     /* 2542 */ // Label 185: @2542
     /* 2542 */ GIM_Reject,
     /* 2543 */ // Label 30: @2543
     /* 2543 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2554), // Rule ID 36 //
     /* 2548 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 2551 */   // Combiner Rule #28: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 2551 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 2554 */ // Label 186: @2554
     /* 2554 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2565), // Rule ID 38 //
     /* 2559 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 2562 */   // Combiner Rule #29: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 2562 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 2565 */ // Label 187: @2565
     /* 2565 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2576), // Rule ID 64 //
     /* 2570 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 2573 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 2573 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2576 */ // Label 188: @2576
     /* 2576 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2587), // Rule ID 96 //
     /* 2581 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 2584 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 2584 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 2587 */ // Label 189: @2587
     /* 2587 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2598), // Rule ID 132 //
     /* 2592 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 2595 */   // Combiner Rule #76: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 2595 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 2598 */ // Label 190: @2598
     /* 2598 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2621), // Rule ID 89 //
     /* 2603 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2606 */   // MIs[0] dst
     /* 2606 */   // No operand predicates
     /* 2606 */   // MIs[0] lhs
     /* 2606 */   // No operand predicates
     /* 2606 */   // MIs[0] Operand 2
     /* 2606 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2610 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2615 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 2615 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2620 */   GIR_EraseRootFromParent_Done,
     /* 2621 */ // Label 191: @2621
     /* 2621 */ GIM_Reject,
     /* 2622 */ // Label 31: @2622
     /* 2622 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2633), // Rule ID 35 //
     /* 2627 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 2630 */   // Combiner Rule #28: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 2630 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 2633 */ // Label 192: @2633
     /* 2633 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2644), // Rule ID 37 //
     /* 2638 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 2641 */   // Combiner Rule #29: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 2641 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 2644 */ // Label 193: @2644
     /* 2644 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2655), // Rule ID 63 //
     /* 2649 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 2652 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 2652 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2655 */ // Label 194: @2655
     /* 2655 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2666), // Rule ID 97 //
     /* 2660 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 2663 */   // Combiner Rule #53: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 2663 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 2666 */ // Label 195: @2666
     /* 2666 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(2677), // Rule ID 131 //
     /* 2671 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 2674 */   // Combiner Rule #76: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 2674 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 2677 */ // Label 196: @2677
     /* 2677 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(2700), // Rule ID 88 //
     /* 2682 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2685 */   // MIs[0] dst
     /* 2685 */   // No operand predicates
     /* 2685 */   // MIs[0] lhs
     /* 2685 */   // No operand predicates
     /* 2685 */   // MIs[0] Operand 2
     /* 2685 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2689 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2694 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 2694 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2699 */   GIR_EraseRootFromParent_Done,
     /* 2700 */ // Label 197: @2700
     /* 2700 */ GIM_Reject,
     /* 2701 */ // Label 32: @2701
     /* 2701 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(2712), // Rule ID 39 //
     /* 2706 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 2709 */   // Combiner Rule #30: rotate_out_of_range; wip_match_opcode 'G_ROTR'
     /* 2709 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 2712 */ // Label 198: @2712
     /* 2712 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(2735), // Rule ID 92 //
     /* 2717 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2720 */   // MIs[0] dst
     /* 2720 */   // No operand predicates
     /* 2720 */   // MIs[0] lhs
     /* 2720 */   // No operand predicates
     /* 2720 */   // MIs[0] Operand 2
     /* 2720 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2724 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2729 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 2729 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2734 */   GIR_EraseRootFromParent_Done,
     /* 2735 */ // Label 199: @2735
     /* 2735 */ GIM_Reject,
     /* 2736 */ // Label 33: @2736
     /* 2736 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(2747), // Rule ID 40 //
     /* 2741 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 2744 */   // Combiner Rule #30: rotate_out_of_range; wip_match_opcode 'G_ROTL'
     /* 2744 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 2747 */ // Label 200: @2747
     /* 2747 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(2770), // Rule ID 91 //
     /* 2752 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 2755 */   // MIs[0] dst
     /* 2755 */   // No operand predicates
     /* 2755 */   // MIs[0] lhs
     /* 2755 */   // No operand predicates
     /* 2755 */   // MIs[0] Operand 2
     /* 2755 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2759 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2764 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 2764 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2769 */   GIR_EraseRootFromParent_Done,
     /* 2770 */ // Label 201: @2770
     /* 2770 */ GIM_Reject,
     /* 2771 */ // Label 34: @2771
     /* 2771 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(2782), // Rule ID 41 //
     /* 2776 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 2779 */   // Combiner Rule #31: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 2779 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 2782 */ // Label 202: @2782
     /* 2782 */ GIM_Reject,
     /* 2783 */ // Label 35: @2783
     /* 2783 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(2794), // Rule ID 47 //
     /* 2788 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 2791 */   // Combiner Rule #35: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 2791 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 2794 */ // Label 203: @2794
     /* 2794 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(2805), // Rule ID 49 //
     /* 2799 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 2802 */   // Combiner Rule #37: match_selects; wip_match_opcode 'G_SELECT'
     /* 2802 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 2805 */ // Label 204: @2805
     /* 2805 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(2816), // Rule ID 82 //
     /* 2810 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 2813 */   // Combiner Rule #50: select_same_val; wip_match_opcode 'G_SELECT'
     /* 2813 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 2816 */ // Label 205: @2816
     /* 2816 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(2827), // Rule ID 150 //
     /* 2821 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2824 */   // Combiner Rule #84: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 2824 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 2827 */ // Label 206: @2827
     /* 2827 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(2848), // Rule ID 48 //
     /* 2832 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 2835 */   // MIs[0] root
     /* 2835 */   // No operand predicates
     /* 2835 */   // MIs[0] tst
     /* 2835 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2839 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2843 */   // MIs[1] tst1
     /* 2843 */   // No operand predicates
     /* 2843 */   // MIs[1] a
     /* 2843 */   // No operand predicates
     /* 2843 */   // MIs[1] b
     /* 2843 */   // No operand predicates
     /* 2843 */   // MIs[0] x
     /* 2843 */   // No operand predicates
     /* 2843 */   // MIs[0] y
     /* 2843 */   // No operand predicates
     /* 2843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2845 */   // Combiner Rule #36: select_to_iminmax
     /* 2845 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 2848 */ // Label 207: @2848
     /* 2848 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(2877), // Rule ID 46 //
     /* 2853 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 2856 */   // MIs[0] dst
     /* 2856 */   // No operand predicates
     /* 2856 */   // MIs[0] undef
     /* 2856 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 2864 */   // MIs[0] x
     /* 2864 */   // No operand predicates
     /* 2864 */   // MIs[0] y
     /* 2864 */   // No operand predicates
     /* 2864 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 2869 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2871 */   // Combiner Rule #34: select_undef_cmp
     /* 2871 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 2876 */   GIR_EraseRootFromParent_Done,
     /* 2877 */ // Label 208: @2877
     /* 2877 */ GIM_Reject,
     /* 2878 */ // Label 36: @2878
     /* 2878 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(2889), // Rule ID 43 //
     /* 2883 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 2886 */   // Combiner Rule #32: match_addos; wip_match_opcode 'G_UADDO'
     /* 2886 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 2889 */ // Label 209: @2889
     /* 2889 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(2900), // Rule ID 162 //
     /* 2894 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2897 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 2897 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2900 */ // Label 210: @2900
     /* 2900 */ GIM_Reject,
     /* 2901 */ // Label 37: @2901
     /* 2901 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(2912), // Rule ID 45 //
     /* 2906 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 2909 */   // Combiner Rule #33: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 2909 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 2912 */ // Label 211: @2912
     /* 2912 */ GIM_Reject,
     /* 2913 */ // Label 38: @2913
     /* 2913 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(2924), // Rule ID 42 //
     /* 2918 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 2921 */   // Combiner Rule #32: match_addos; wip_match_opcode 'G_SADDO'
     /* 2921 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 2924 */ // Label 212: @2924
     /* 2924 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(2935), // Rule ID 163 //
     /* 2929 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2932 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 2932 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2935 */ // Label 213: @2935
     /* 2935 */ GIM_Reject,
     /* 2936 */ // Label 39: @2936
     /* 2936 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(2947), // Rule ID 44 //
     /* 2941 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 2944 */   // Combiner Rule #33: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 2944 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 2947 */ // Label 214: @2947
     /* 2947 */ GIM_Reject,
     /* 2948 */ // Label 40: @2948
     /* 2948 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(2959), // Rule ID 164 //
     /* 2953 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2956 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 2956 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2959 */ // Label 215: @2959
     /* 2959 */ GIM_Reject,
     /* 2960 */ // Label 41: @2960
     /* 2960 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(2971), // Rule ID 165 //
     /* 2965 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2968 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 2968 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2971 */ // Label 216: @2971
     /* 2971 */ GIM_Reject,
     /* 2972 */ // Label 42: @2972
     /* 2972 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(2983), // Rule ID 166 //
     /* 2977 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2980 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 2980 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2983 */ // Label 217: @2983
     /* 2983 */ GIM_Reject,
     /* 2984 */ // Label 43: @2984
     /* 2984 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(2995), // Rule ID 167 //
     /* 2989 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2992 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 2992 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 2995 */ // Label 218: @2995
     /* 2995 */ GIM_Reject,
     /* 2996 */ // Label 44: @2996
     /* 2996 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3007), // Rule ID 168 //
     /* 3001 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3004 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 3004 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3007 */ // Label 219: @3007
     /* 3007 */ GIM_Reject,
     /* 3008 */ // Label 45: @3008
     /* 3008 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3019), // Rule ID 169 //
     /* 3013 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3016 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 3016 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3019 */ // Label 220: @3019
     /* 3019 */ GIM_Reject,
     /* 3020 */ // Label 46: @3020
     /* 3020 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3031), // Rule ID 170 //
     /* 3025 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3028 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 3028 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3031 */ // Label 221: @3031
     /* 3031 */ GIM_Reject,
     /* 3032 */ // Label 47: @3032
     /* 3032 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3043), // Rule ID 171 //
     /* 3037 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3040 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 3040 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3043 */ // Label 222: @3043
     /* 3043 */ GIM_Reject,
     /* 3044 */ // Label 48: @3044
     /* 3044 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3055), // Rule ID 172 //
     /* 3049 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3052 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 3052 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3055 */ // Label 223: @3055
     /* 3055 */ GIM_Reject,
     /* 3056 */ // Label 49: @3056
     /* 3056 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3067), // Rule ID 173 //
     /* 3061 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3064 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 3064 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3067 */ // Label 224: @3067
     /* 3067 */ GIM_Reject,
     /* 3068 */ // Label 50: @3068
     /* 3068 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3079), // Rule ID 78 //
     /* 3073 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3076 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 3076 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3079 */ // Label 225: @3079
     /* 3079 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3090), // Rule ID 174 //
     /* 3084 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3087 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 3087 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3090 */ // Label 226: @3090
     /* 3090 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3113), // Rule ID 117 //
     /* 3095 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3098 */   // MIs[0] dst
     /* 3098 */   // No operand predicates
     /* 3098 */   // MIs[0] x
     /* 3098 */   // No operand predicates
     /* 3098 */   // MIs[0] y
     /* 3098 */   // No operand predicates
     /* 3098 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3102 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3107 */   // Combiner Rule #67: right_identity_neg_zero_fp
     /* 3107 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3112 */   GIR_EraseRootFromParent_Done,
     /* 3113 */ // Label 227: @3113
     /* 3113 */ GIM_Reject,
     /* 3114 */ // Label 51: @3114
     /* 3114 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3125), // Rule ID 79 //
     /* 3119 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3122 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 3122 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3125 */ // Label 228: @3125
     /* 3125 */ GIM_Reject,
     /* 3126 */ // Label 52: @3126
     /* 3126 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3137), // Rule ID 80 //
     /* 3131 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3134 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 3134 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3137 */ // Label 229: @3137
     /* 3137 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3148), // Rule ID 175 //
     /* 3142 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3145 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 3145 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3148 */ // Label 230: @3148
     /* 3148 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3171), // Rule ID 108 //
     /* 3153 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3156 */   // MIs[0] dst
     /* 3156 */   // No operand predicates
     /* 3156 */   // MIs[0] x
     /* 3156 */   // No operand predicates
     /* 3156 */   // MIs[0] y
     /* 3156 */   // No operand predicates
     /* 3156 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 3160 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3165 */   // Combiner Rule #60: right_identity_one_fp
     /* 3165 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3170 */   GIR_EraseRootFromParent_Done,
     /* 3171 */ // Label 231: @3171
     /* 3171 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3191), // Rule ID 118 //
     /* 3176 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3179 */   // MIs[0] dst
     /* 3179 */   // No operand predicates
     /* 3179 */   // MIs[0] x
     /* 3179 */   // No operand predicates
     /* 3179 */   // MIs[0] y
     /* 3179 */   // No operand predicates
     /* 3179 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 3183 */   // Combiner Rule #68: right_identity_neg_one_fp
     /* 3183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 3186 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 3188 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 3190 */   GIR_EraseRootFromParent_Done,
     /* 3191 */ // Label 232: @3191
     /* 3191 */ GIM_Reject,
     /* 3192 */ // Label 53: @3192
     /* 3192 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3203), // Rule ID 81 //
     /* 3197 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3200 */   // Combiner Rule #49: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 3200 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3203 */ // Label 233: @3203
     /* 3203 */ GIM_Reject,
     /* 3204 */ // Label 54: @3204
     /* 3204 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3233), // Rule ID 106 //
     /* 3209 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3212 */   // MIs[0] dst
     /* 3212 */   // No operand predicates
     /* 3212 */   // MIs[0] t
     /* 3212 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3216 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 3220 */   // MIs[1] src
     /* 3220 */   // No operand predicates
     /* 3220 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 3225 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3227 */   // Combiner Rule #58: fneg_fneg_fold
     /* 3227 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 3232 */   GIR_EraseRootFromParent_Done,
     /* 3233 */ // Label 234: @3233
     /* 3233 */ GIM_Reject,
     /* 3234 */ // Label 55: @3234
     /* 3234 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3255), // Rule ID 116 //
     /* 3239 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 3242 */   // MIs[0] dst
     /* 3242 */   // No operand predicates
     /* 3242 */   // MIs[0] src1
     /* 3242 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 3250 */   // MIs[1] src0
     /* 3250 */   // No operand predicates
     /* 3250 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3252 */   // Combiner Rule #66: fptrunc_fpext_fold
     /* 3252 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3255 */ // Label 235: @3255
     /* 3255 */ GIM_Reject,
     /* 3256 */ // Label 56: @3256
     /* 3256 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3277), // Rule ID 139 //
     /* 3261 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3264 */   // MIs[0] dst
     /* 3264 */   // No operand predicates
     /* 3264 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3264 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3272 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3274 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 3274 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 3277 */ // Label 236: @3277
     /* 3277 */ GIM_Reject,
     /* 3278 */ // Label 57: @3278
     /* 3278 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3299), // Rule ID 140 //
     /* 3283 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3286 */   // MIs[0] dst
     /* 3286 */   // No operand predicates
     /* 3286 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3286 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3290 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3294 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3296 */   // Combiner Rule #78: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 3296 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 3299 */ // Label 237: @3299
     /* 3299 */ GIM_Reject,
     /* 3300 */ // Label 58: @3300
     /* 3300 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3311), // Rule ID 123 //
     /* 3305 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 3308 */   // Combiner Rule #72: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 3308 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 3311 */ // Label 238: @3311
     /* 3311 */ GIM_Reject,
     /* 3312 */ // Label 59: @3312
     /* 3312 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3323), // Rule ID 122 //
     /* 3317 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 3320 */   // Combiner Rule #72: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 3320 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 3323 */ // Label 239: @3323
     /* 3323 */ GIM_Reject,
     /* 3324 */ // Label 60: @3324
     /* 3324 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3335), // Rule ID 176 //
     /* 3329 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3332 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 3332 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3335 */ // Label 240: @3335
     /* 3335 */ GIM_Reject,
     /* 3336 */ // Label 61: @3336
     /* 3336 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3347), // Rule ID 177 //
     /* 3341 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3344 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 3344 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3347 */ // Label 241: @3347
     /* 3347 */ GIM_Reject,
     /* 3348 */ // Label 62: @3348
     /* 3348 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3359), // Rule ID 178 //
     /* 3353 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3356 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 3356 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3359 */ // Label 242: @3359
     /* 3359 */ GIM_Reject,
     /* 3360 */ // Label 63: @3360
     /* 3360 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3371), // Rule ID 179 //
     /* 3365 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3368 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 3368 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3371 */ // Label 243: @3371
     /* 3371 */ GIM_Reject,
     /* 3372 */ // Label 64: @3372
     /* 3372 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3383), // Rule ID 180 //
     /* 3377 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3380 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 3380 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3383 */ // Label 244: @3383
     /* 3383 */ GIM_Reject,
     /* 3384 */ // Label 65: @3384
     /* 3384 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3395), // Rule ID 181 //
     /* 3389 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3392 */   // Combiner Rule #88: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 3392 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 3395 */ // Label 245: @3395
     /* 3395 */ GIM_Reject,
     /* 3396 */ // Label 66: @3396
     /* 3396 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3407), // Rule ID 61 //
     /* 3401 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3404 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 3404 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3407 */ // Label 246: @3407
     /* 3407 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3418), // Rule ID 119 //
     /* 3412 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 3415 */   // Combiner Rule #69: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 3415 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3418 */ // Label 247: @3418
     /* 3418 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3441), // Rule ID 90 //
     /* 3423 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3426 */   // MIs[0] dst
     /* 3426 */   // No operand predicates
     /* 3426 */   // MIs[0] lhs
     /* 3426 */   // No operand predicates
     /* 3426 */   // MIs[0] Operand 2
     /* 3426 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3430 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3435 */   // Combiner Rule #51: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 3435 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3440 */   GIR_EraseRootFromParent_Done,
     /* 3441 */ // Label 248: @3441
     /* 3441 */ GIM_Reject,
     /* 3442 */ // Label 67: @3442
     /* 3442 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(3453), // Rule ID 74 //
     /* 3447 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3450 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 3450 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3453 */ // Label 249: @3453
     /* 3453 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(3464), // Rule ID 158 //
     /* 3458 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3461 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 3461 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3464 */ // Label 250: @3464
     /* 3464 */ GIM_Reject,
     /* 3465 */ // Label 68: @3465
     /* 3465 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(3476), // Rule ID 75 //
     /* 3470 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3473 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 3473 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3476 */ // Label 251: @3476
     /* 3476 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(3487), // Rule ID 159 //
     /* 3481 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3484 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 3484 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3487 */ // Label 252: @3487
     /* 3487 */ GIM_Reject,
     /* 3488 */ // Label 69: @3488
     /* 3488 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(3499), // Rule ID 76 //
     /* 3493 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3496 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 3496 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3499 */ // Label 253: @3499
     /* 3499 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(3510), // Rule ID 160 //
     /* 3504 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3507 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 3507 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3510 */ // Label 254: @3510
     /* 3510 */ GIM_Reject,
     /* 3511 */ // Label 70: @3511
     /* 3511 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(3522), // Rule ID 77 //
     /* 3516 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3519 */   // Combiner Rule #48: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 3519 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3522 */ // Label 255: @3522
     /* 3522 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(3533), // Rule ID 161 //
     /* 3527 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 3530 */   // Combiner Rule #87: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 3530 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 3533 */ // Label 256: @3533
     /* 3533 */ GIM_Reject,
     /* 3534 */ // Label 71: @3534
     /* 3534 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(3545), // Rule ID 133 //
     /* 3539 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3542 */   // Combiner Rule #77: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 3542 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 3545 */ // Label 257: @3545
     /* 3545 */ GIM_Reject,
     /* 3546 */ // Label 72: @3546
     /* 3546 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(3557), // Rule ID 148 //
     /* 3551 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 3554 */   // Combiner Rule #83: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 3554 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 3557 */ // Label 258: @3557
     /* 3557 */ GIM_Reject,
     /* 3558 */ // Label 73: @3558
     /* 3558 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(3569), // Rule ID 29 //
     /* 3563 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 3566 */   // Combiner Rule #22: extractvecelt_pairwise_add; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 3566 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 3569 */ // Label 259: @3569
     /* 3569 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(3580), // Rule ID 149 //
     /* 3574 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 3577 */   // Combiner Rule #83: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 3577 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 3580 */ // Label 260: @3580
     /* 3580 */ GIM_Reject,
     /* 3581 */ // Label 74: @3581
     /* 3581 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(3592), // Rule ID 144 //
     /* 3586 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 3589 */   // Combiner Rule #80: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 3589 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 3592 */ // Label 261: @3592
     /* 3592 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(3603), // Rule ID 146 //
     /* 3597 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 3600 */   // Combiner Rule #81: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 3600 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 3603 */ // Label 262: @3603
     /* 3603 */ GIM_Reject,
     /* 3604 */ // Label 75: @3604
     /* 3604 */ GIM_Reject,
     /* 3605 */ }; // Size: 3605 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

